module Chickadee
  class NumericID
    include Comparable

    def initialize(id)
      raise(ArgumentError, "invalid id: #{id}") unless id.is_a?(Integer) && id > 0
      @id = id
    end

    def to_i
      @id
    end

    def <=>(other)
      self.to_i <=> other.to_i
    end

    def ==(other)
      self.class == other.class && self.hash == other.hash
    end

    def eql?(other)
      self == other
    end

    def hash
      @id.hash
    end
  end
end