module Chickadee
  class UUID
    UUID_REGEX = /^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/

    def initialize(uuid)
      raise(ArgumentError, "invalid uuid: #{uuid}") unless uuid.is_a?(String) && uuid.match(UUID_REGEX)
      @uuid = uuid
    end

    def to_s
      @uuid
    end

    def ==(other)
      self.class == other.class && self.hash == other.hash
    end

    def eql?(other)
      self == other
    end

    def hash
      @uuid.hash
    end
  end
end